/* === S Y N F I G ========================================================= */
/*!	\file synfigapp/actions/valuedescbonesetparent.h
**	\brief Template File
**
**	\legal
**  Copyright (c) 2020 Aditya Abhiram J
**
**	This file is part of Synfig.
**
**	Synfig is free software: you can redistribute it and/or modify
**	it under the terms of the GNU General Public License as published by
**	the Free Software Foundation, either version 2 of the License, or
**	(at your option) any later version.
**
**	Synfig is distributed in the hope that it will be useful,
**	but WITHOUT ANY WARRANTY; without even the implied warranty of
**	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**	GNU General Public License for more details.
**
**	You should have received a copy of the GNU General Public License
**	along with Synfig.  If not, see <https://www.gnu.org/licenses/>.
**	\endlegal
*/
/* ========================================================================= */

/* === S T A R T =========================================================== */

#ifndef __SYNFIG_APP_ACTION_ValueDescBoneSetParent_H
#define __SYNFIG_APP_ACTION_ValueDescBoneSetParent_H

/* === H E A D E R S ======================================================= */

#include <synfigapp/action.h>
#include <synfig/valuenodes/valuenode_bone.h>

/* === M A C R O S ========================================================= */

/* === T Y P E D E F S ===================================================== */

/* === C L A S S E S & S T R U C T S ======================================= */

namespace synfigapp {

namespace Action {

class ValueDescBoneSetParent :
	public Super
{
private:
	ValueDesc value_desc;
	synfig::ValueNode_Bone::Handle active_bone_;
	synfig::Time time;

	void add_action_set_interpolation(synfig::ValueNode_Bone::Handle bone_valuenode, const char *link_name, synfig::Interpolation interpolation);
	void add_action_set_valuedesc(synfig::ValueNode_Bone::Handle bone_valuenode, const char *link_name, const synfig::ValueBase& value);

public:

	ValueDescBoneSetParent();

	static ParamVocab get_param_vocab();
	static bool is_candidate(const ParamList &x);

	virtual bool set_param(const synfig::String& name, const Param &);
	virtual bool is_ready()const;

	virtual void prepare();

	ACTION_MODULE_EXT
};

}; // END of namespace action
}; // END of namespace studio

/* === E N D =============================================================== */

#endif
